您的位置:首页 > 产品设计 > UI/UE

hdu 1806 Frequent values (RMQ)

2017-01-08 22:30 615 查看
Problem Description

You are given a sequence of n integers a1 , a2 , ... , an in non-decreasing order. In addition to that, you are given several queries consisting of indices i and j (1 ≤ i ≤ j ≤ n). For each query, determine the most frequent
value among the integers ai , ... , aj . 

 

Input

The input consists of several test cases. Each test case starts with a line containing two integers n and q (1 ≤ n, q ≤ 100000). The next line contains n integers a1 , ... , an(-100000 ≤ ai ≤ 100000, for each i ∈ {1, ..., n})
separated by spaces. You can assume that for each i ∈ {1, ..., n-1}: ai ≤ ai+1. The following q lines contain one query each, consisting of two integers i and j (1 ≤ i ≤ j ≤ n), which indicate the boundary indices for the query. 

The last test case is followed by a line containing a single 0. 

 

Output

For each query, print one line with one integer: The number of occurrences of the most frequent value within the given range. 

 

Sample Input

10 3
-1 -1 1 1 1 1 3 10 10 10
2 3
1 10
5 10
0

 

Sample Output

1
4
3

Hint
A naive algorithm may not run in time!

 

Source

HDOJ 2007 Summer Exercise(1)

 

题意:查询某个区间出现次数最多数字的次数.

思路:RMQ算法,由于给出的序列是非减的,我们可以将序列优化一下,将数字出现的次数作为序列值;

列如:(1,1,,2,2,2,3)  优化成(2,3,1)

于是RMQ;

代码:

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<cmath>
using namespace std;
const int N=100010;
int a
,b
;
int dp
[20];
void make_rmq(int n)
{
for(int i=0;i<n;i++)
dp[i][0]=b[i];
for(int j=1;(1<<j)<n;j++)
for(int i=0;i+(1<<j)<n;i++)
dp[i][j]=max(dp[i][j-1],dp[i+(1<<(j-1))][j-1]);
}
int find1(int l,int r,int w)
{
while(l<r)
{
int temp=(l+r)/2;
if(a[temp]>=w)
r=temp;
else
l=temp+1;
}
return l;
}
int rmp(int l,int r)
{
int n=(int)(log(r-l+1.0)/log(2));
return max(dp[l]
,dp[r-(1<<n)+1]
);
}
int main()
{
int n,m;
while(~scanf("%d",&n))
{
if(!n)
break;
scanf("%d",&m);
for(int i=0;i<n;i++)
scanf("%d",&a[i]);
int t=1,temp=a[n-1];
b[n-1]=1;
for(int i=n-2;i>=0;i--)
{
if(temp==a[i])
t++;
else
{
temp=a[i];
t=1;
}
b[i]=t;
}
make_rmq(n);
while(m--)
{
int l,r;
scanf("%d%d",&l,&r);
l--;
r--;
int tt=find1(l,r,a[r]);
int ans=r-tt+1;
r=tt-1;
if(l>r)
printf("%d\n",ans);
else
printf("%d\n",max(ans,rmp(l,r)));
}
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: